function failed(fcId, arg) {
    console.log("CIT_PROD: Failed! - process aborted: " + arg);
}

console.log("CIT_PROD: Reading capabilities");
zway.ZMECapabilities(undefined, function() {
    if (zway.controller.data.caps.value == [ 0x01, 0x15, 0xFF, 0x0D]) {
        console.log("CIT_PROD: License is already loaded");
        return;
    }
    var uuid = zway.controller.data.uuid.value;
    var uuid_str = "";
    for (var n = 0; n < 32; n += 2) {
        uuid_str += (n ? " " : "") + uuid[n] + uuid[n+1];
    }
    console.log("CIT_PROD: UUID: " + uuid_str);
    try {
        var ret = system("'/home/ps/Desktop/Zwave/Projects/CIT/6.70 tests/MemberLicense/utility_uzb_sign.py' uzb_sign '" + uuid_str + "' '01 15 FF 0D' | grep HEX | cut -f 2 -d : | cut -f 1 -d '('");
    } catch(e) {
        failed(0, "uzb_sign failed: " + e);
        return;
    }
    if (ret[0]) {
        failed(0, "uzb_sign failed");
        return;
    }
    console.log("got reply: " + ret[1]);
    try {
        var lic = ret[1].trim().split(" ").map(function(x) { return parseInt(x, 16)});
    } catch(e) {
        failed(0, "uzb_sign failed: " + e);
        return;
    }
    if (! (lic.length > 0)) {
        failed(0, "License parse error");
        return;
    }
    console.log("CIT_PROD: Setting license: " + lic);
    zway.ZMECapabilities(lic, function() {
        if (JSON.stringify(zway.controller.data.caps.value) !== JSON.stringify([ 0x01, 0x15, 0xFF, 0x0D])) {
            failed(0, "License was not applied");
            return;
        }
        try {
            var ret = system("'/home/ps/Desktop/Zwave/Projects/CIT/6.70 tests/MemberLicense/utility_uzb_sign.py' inst_sign '" + uuid_str + "' '" + zway.controller.data.capsNonce.value.map(function(x) { return x.toString(16); }).join(" ") + "' | grep PACKET | cut -f 2 -d :");
        } catch(e) {
            failed(0, "inst_sign failed: " + e);
            return;
        }
        if (ret[0]) {
            failed(0, "inst_sign failed");
            return;
        }
        console.log("got reply: " + ret[1]);
        try {
            var key = ret[1].trim().split(" ").map(function(x) { return parseInt(x, 16)});
        } catch(e) {
            failed(0, "inst_sign failed: " + e);
            return;
        }
        console.log("CIT_PROD: Setting countdown key: " + key);
        zway.ZMECapabilities(key, function() {
            zway.ZMECapabilities(undefined, function() {
                if (zway.controller.data.countDown.value > 30) {
                    failed(0, "Key was not applied");
                    return;
                }
                console.log("CIT_PROD: Done!");
            }, failed, "Checking countdown key");
        }, failed, "Setting countdown key");
    }, failed, "Setting license");
}, failed, "reading capabilities");
